-- general OpenGL function for GEM

require('opengl')

local M = pd.Class:new():register("gl")

function M:initialize(name,atoms)
	glname = table.remove(atoms,1)
	self.glfun = gl[glname]
	if self.glfun then
		self.args = atoms
		self.inlets = (#self.args)+1
		self.outlets = 1
	    return true
	else
		return false
	end
end

function M:in_1_gem_state(atoms)
	self.glfun(unpack(self.args))
	self:outlet(1,"gem_state",atoms)
end

function M:in_n(inlet,sel,atom)
	if sel == 'float' then
		self.args[inlet-1] = atom[1]
	else
		self:error('Only float values')
	end
end
